/*
	*
	* Copyright 2019 Britanicus <marcusbritanicus@gmail.com>
	*
	* This file is a part of DesQ project ( https://gitlab.com/desq/ )
	*

	*
	* This program is free software; you can redistribute it and/or modify
	* it under the terms of the GNU General Public License as published by
	* the Free Software Foundation; either version 3 of the License, or
	* (at your option) any later version.
	*

	*
	* This program is distributed in the hope that it will be useful,
	* but WITHOUT ANY WARRANTY; without even the implied warranty of
	* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	* GNU General Public License for more details.
	*

	*
	* You should have received a copy of the GNU General Public License
	* along with this program; if not, write to the Free Software
	* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
	* MA 02110-1301, USA.
	*
*/

#include "DesQSessionAdaptor.hpp"
#include <QtCore/QMetaObject>
#include <QtCore/QByteArray>
#include <QtCore/QList>
#include <QtCore/QMap>
#include <QtCore/QString>
#include <QtCore/QStringList>
#include <QtCore/QVariant>

SessionAdaptor::SessionAdaptor( QObject *parent ) : QDBusAbstractAdaptor( parent ) {

    setAutoRelaySignals( true );
};

SessionAdaptor::~SessionAdaptor() {

};

void SessionAdaptor::hibernate() {

    QMetaObject::invokeMethod( parent(), "hibernate" );
};

void SessionAdaptor::lock() {
    // handle method call org.DesQ.Session.lock
    QMetaObject::invokeMethod( parent(), "lock" );
};

void SessionAdaptor::logout() {

    QMetaObject::invokeMethod( parent(), "logout" );
};

void SessionAdaptor::reboot() {

    QMetaObject::invokeMethod( parent(), "reboot" );
};

void SessionAdaptor::shutdown() {

    QMetaObject::invokeMethod( parent(), "shutdown" );
};

void SessionAdaptor::suspend() {

    QMetaObject::invokeMethod( parent(), "suspend" );
};
