/*
	*
	* Copyright 2019 Britanicus <marcusbritanicus@gmail.com>
	*
	* This file is a part of DesQ project ( https://gitlab.com/desq/ )
	*

	*
	* This program is free software; you can redistribute it and/or modify
	* it under the terms of the GNU General Public License as published by
	* the Free Software Foundation; either version 3 of the License, or
	* (at your option) any later version.
	*

	*
	* This program is distributed in the hope that it will be useful,
	* but WITHOUT ANY WARRANTY; without even the implied warranty of
	* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	* GNU General Public License for more details.
	*

	*
	* You should have received a copy of the GNU General Public License
	* along with this program; if not, write to the Free Software
	* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
	* MA 02110-1301, USA.
	*
*/

#pragma once

#include <QtCore/QObject>
#include <QtDBus/QtDBus>
#include <QtCore/qcontainerfwd.h>

class SessionAdaptor: public QDBusAbstractAdaptor {

    Q_OBJECT;
    Q_CLASSINFO( "D-Bus Interface", "org.desq.Session" );
    Q_CLASSINFO( "D-Bus Introspection", ""
        "<interface name='org.DesQ.Session'>"
        "   <method name='lock'/>"
        "   <method name='logout'/>"
        "   <method name='suspend'/>"
        "   <method name='hibernate'/>"
        "   <method name='shutdown'/>"
        "   <method name='reboot'/>"
        "</interface>"
    );

    public:
        SessionAdaptor( QObject *parent );
        virtual ~SessionAdaptor();

    public Q_SLOTS:
        void hibernate();
        void lock();
        void logout();
        void reboot();
        void shutdown();
        void suspend();
};
